"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var _this = this;
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var graphql_toolkit_1 = require("graphql-toolkit");
var visitor_1 = require("./visitor");
var path_1 = require("path");
var graphql_tag_1 = require("graphql-tag");
exports.plugin = function (schema, documents, config) {
    var visitor = new visitor_1.TsMongoVisitor(schema, config);
    var printedSchema = graphql_toolkit_1.printSchemaWithDirectives(schema);
    var astNode = graphql_1.parse(printedSchema);
    var header = "type Maybe<T> = " + visitor.config.maybeValue + ";";
    var visitorResult = graphql_1.visit(astNode, { leave: visitor });
    return [header].concat(visitorResult.definitions.filter(function (d) { return typeof d === 'string'; })).join('\n');
};
var Directives;
(function (Directives) {
    Directives["ID"] = "id";
    Directives["ENTITY"] = "entity";
    Directives["ABSTRACT_ENTITY"] = "abstractEntity";
    Directives["UNION"] = "union";
    Directives["LINK"] = "link";
    Directives["COLUMN"] = "column";
    Directives["EMBEDDED"] = "embedded";
    Directives["MAP"] = "map";
})(Directives = exports.Directives || (exports.Directives = {}));
exports.addToSchema = graphql_tag_1.default(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  directive @", "(discriminatorField: String) on UNION\n  directive @", "(discriminatorField: String!) on INTERFACE\n  directive @", "(embedded: Boolean, additionalFields: [AdditionalEntityFields]) on OBJECT\n  directive @", "(name: String, overrideType: String, overrideIsArray: Boolean) on FIELD_DEFINITION\n  directive @", " on FIELD_DEFINITION\n  directive @", " on FIELD_DEFINITION\n  directive @", " on FIELD_DEFINITION\n  directive @", "(path: String!) on FIELD_DEFINITION\n  # Inputs\n  input AdditionalEntityFields {\n    path: String\n    type: String\n  }\n"], ["\n  directive @", "(discriminatorField: String) on UNION\n  directive @", "(discriminatorField: String!) on INTERFACE\n  directive @", "(embedded: Boolean, additionalFields: [AdditionalEntityFields]) on OBJECT\n  directive @", "(name: String, overrideType: String, overrideIsArray: Boolean) on FIELD_DEFINITION\n  directive @", " on FIELD_DEFINITION\n  directive @", " on FIELD_DEFINITION\n  directive @", " on FIELD_DEFINITION\n  directive @", "(path: String!) on FIELD_DEFINITION\n  # Inputs\n  input AdditionalEntityFields {\n    path: String\n    type: String\n  }\n"])), Directives.UNION, Directives.ABSTRACT_ENTITY, Directives.ENTITY, Directives.COLUMN, Directives.ID, Directives.LINK, Directives.EMBEDDED, Directives.MAP);
exports.validate = function (schema, documents, config, outputFile) { return __awaiter(_this, void 0, void 0, function () {
    return __generator(this, function (_a) {
        if (path_1.extname(outputFile) !== '.ts') {
            throw new Error("Plugin \"typescript-mongodb\" requires extension to be \".ts\"!");
        }
        return [2 /*return*/];
    });
}); };
var templateObject_1;
//# sourceMappingURL=index.js.map