import { TsVisitor, TypeScriptPluginParsedConfig } from 'graphql-codegen-typescript';
import { TypeScriptPluginConfig } from './index';
import { ASTNode, GraphQLSchema } from 'graphql';
import { BaseVisitorConvertOptions, ConvertOptions } from 'graphql-codegen-visitor-plugin-common';
export interface TypeScriptMongoPluginParsedConfig extends TypeScriptPluginParsedConfig {
    dbTypeSuffix: string;
    dbInterfaceSuffix: string;
    objectIdType: string;
    idFieldName: string;
    enumsAsString: boolean;
}
export declare class TsMongoVisitor extends TsVisitor<TypeScriptPluginConfig, TypeScriptMongoPluginParsedConfig> {
    private _schema;
    constructor(_schema: GraphQLSchema, pluginConfig: TypeScriptPluginConfig);
    private _getDirective;
    protected convertName(node: ASTNode | string, options?: BaseVisitorConvertOptions & ConvertOptions): string;
}
