"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_codegen_typescript_1 = require("graphql-codegen-typescript");
var index_1 = require("./index");
var graphql_1 = require("graphql");
var graphql_codegen_visitor_plugin_common_1 = require("graphql-codegen-visitor-plugin-common");
var TsMongoVisitor = /** @class */ (function (_super) {
    __extends(TsMongoVisitor, _super);
    function TsMongoVisitor(_schema, pluginConfig) {
        var _this = _super.call(this, pluginConfig, {
            dbTypeSuffix: pluginConfig.dbTypeSuffix || 'DbObject',
            dbInterfaceSuffix: pluginConfig.dbInterfaceSuffix || 'DbInterface',
            objectIdType: pluginConfig.objectIdType || 'ObjectID',
            idFieldName: pluginConfig.idFieldName || '_id',
            enumsAsString: graphql_codegen_visitor_plugin_common_1.getConfigValue(pluginConfig.enumsAsString, true)
        }) || this;
        _this._schema = _schema;
        return _this;
    }
    TsMongoVisitor.prototype._getDirective = function (node, directiveName) {
        if (!node || !node.directives || node.directives.length === 0) {
            return null;
        }
        var foundDirective = node.directives.find(function (d) { return d.name === directiveName || (d.name.value && d.name.value === directiveName); });
        if (!foundDirective) {
            return null;
        }
        return foundDirective;
    };
    // FieldDefinition(node: FieldDefinitionNode, key: string | number, parent: any): string {
    //   const idDirective = this._getDirective(node, Directives.ID);
    //   const linkDirective = this._getDirective(node, Directives.LINK);
    //   const columnDirective = this._getDirective(node, Directives.COLUMN);
    //   const embeddedDirective = this._getDirective(node, Directives.EMBEDDED);
    //   const originalNode: FieldDefinitionNode = parent[key];
    //   if (idDirective !== null) {
    //     return indent(
    //       `${this.config.immutableTypes ? 'readonly ' : ''}${this.config.idFieldName}: ${this.config.objectIdType},`
    //     );
    //   } else if (linkDirective !== null) {
    //     const type = this._argumentsTransformer.wrapAstTypeWithModifiers(
    //       this.convertName(originalNode, { suffix: this.config.dbTypeSuffix }) + `['${this.config.idFieldName}']`,
    //       originalNode.type
    //     );
    //     const addOptionalSign = !this.config.avoidOptionals && originalNode.type.kind !== 'NonNullType';
    //     return indent(
    //       `${this.config.immutableTypes ? 'readonly ' : ''}${node.name}${addOptionalSign ? '?' : ''}: ${type},`
    //     );
    //   } else if (columnDirective !== null) {
    //     return super.FieldDefinition(node, key, parent);
    //   } else if (embeddedDirective !== null) {
    //     return super.FieldDefinition(node, key, parent);
    //   }
    //   return null;
    // }
    TsMongoVisitor.prototype.convertName = function (node, options) {
        if (typeof node !== 'string') {
            if (node.kind === graphql_1.Kind.OBJECT_TYPE_DEFINITION) {
                var entityDirective = this._getDirective(node, index_1.Directives.ENTITY);
                return _super.prototype.convertName.call(this, node, __assign({}, options, (entityDirective ? { suffix: this.config.dbTypeSuffix } : {})));
            }
            else if (node.kind === graphql_1.Kind.NAMED_TYPE) {
                var actualType = this._schema.getType(node.name);
                if (graphql_1.isEnumType(actualType) && this.config.enumsAsString) {
                    return this.scalars.String;
                }
                else if (graphql_1.isObjectType(actualType)) {
                    return _super.prototype.convertName.call(this, node, __assign({}, options, { suffix: this.config.dbTypeSuffix }));
                }
                return _super.prototype.convertName.call(this, node, options);
            }
        }
        return _super.prototype.convertName.call(this, node, options);
    };
    return TsMongoVisitor;
}(graphql_codegen_typescript_1.TsVisitor));
exports.TsMongoVisitor = TsMongoVisitor;
//# sourceMappingURL=visitor.js.map